export declare const ArborSerializeAs: unique symbol;
export type Typed = {
    $reviver: string;
    $value: object;
};
export type SerializedExplicitly<T extends Serializable> = ReturnType<T["toJSON"]>["$value"];
export type Serialized<T> = {
    [K in keyof T]: T[K];
};
export type Serializable = {
    toJSON(): Typed;
};
export type Reviver<T = object> = Function & {
    $revive(obj: object): T;
};
export declare class Json {
    #private;
    serialize: <T extends Reviver<object>>(target: T, _context?: unknown) => void;
    serializeAs<T extends Reviver>(key: string): (target: T, _context?: unknown) => void;
    register(...revivers: Reviver[]): void;
    registerReviver(key: string, reviver: Reviver): void;
    stringify(value: object): string;
    parse<T>(value: string): T;
    private reviver;
}
//# sourceMappingURL=index.d.ts.map